<template>
	<div id="dpnr-preparation" class="content">
		<!-- Toggle mode modal -->
		<modal-component v-cloak ref="toggleModeModal">
			<template v-slot:header>
				<template v-if="mode === 'auto'">Semi Auto Mode</template>
				<template v-if="mode === 'semi-auto'">Auto Mode</template>
			</template>
			<template v-slot:body>
				<font-awesome-icon icon="exclamation-triangle" class="fa-7x p-2 trip" />
				<div class="mb-4" v-if="mode === 'auto'">
					Note: All current running batches will be cancelled!
				</div>
				<ValidationObserver ref="observer">
					<ValidationProvider
						v-slot="{ errors }"
						name="access code"
						rules="required"
					>
						<div class="row d-flex align-items-center">
							<div class="col-5">
								<div class="font-weight-600">Access code</div>
							</div>
							<div class="col-7">
								<input
									id="access_code"
									v-model="accessCode"
									class="form-control"
									name="access_code"
									placeholder="Access code"
									style="width: 90%"
									type="password"
								/>
							</div>
						</div>
						<div class="row d-flex">
							<div class="col-12">
								<div class="ml-4 error-message">{{ errors[0] }}</div>
							</div>
						</div>
					</ValidationProvider>
				</ValidationObserver>
			</template>
			<template v-slot:footer>
				<div class="d-flex justify-content-center align-items-center">
					<button
						class="btn btn-blue px-4 py-2"
						style="width: 10rem"
						type="button"
						@click="toggleMode"
					>
						Start
					</button>
					<button
						class="btn btn-grey ml-4 px-4 py-2"
						style="width: 10rem"
						type="button"
						@click="
							accessCode = '';
							hideModal('toggleModeModal');
						"
					>
						Cancel
					</button>
				</div>
			</template>
		</modal-component>
		<!-- End of toggle mode modal -->

		<!-- Start mixing process modal -->
		<modal-component v-cloak ref="startNextProcessModal">
			<template v-slot:header> Start Sequence </template>
			<template v-slot:body>
				<font-awesome-icon
					class="warning-icon"
					icon="exclamation-triangle"
					style="font-size: 7rem"
				/>
				<div class="mt-4 font-weight-500">Start Mixing Process</div>
			</template>
			<template v-slot:footer>
				<div class="d-flex justify-content-center align-items-center">
					<button
						class="btn btn-blue px-4 py-2"
						style="width: 10rem"
						type="button"
						@click="startNextProcess"
					>
						Start
					</button>
					<button
						class="btn btn-grey ml-4 px-4 py-2"
						style="width: 10rem"
						type="button"
						@click="hideModal('startNextProcessModal')"
					>
						Cancel
					</button>
				</div>
			</template>
		</modal-component>
		<!-- End of start mixing process modal -->

		<div class="header d-flex justify-content-between align-items-center">
			<h2>DPNR Preparation</h2>
			<button
				class="btn btn-blue px-5 font-weight-700"
				:class="mode === 'auto' ? 'btn-blue' : 'btn-orange'"
				type="button"
				@click="showModal('toggleModeModal')"
				:disabled="env === 'cloud'"
			>
				<template v-if="mode === 'auto'">Auto Mode</template>
				<template v-if="mode === 'semi-auto'">Semi Auto Mode</template>
			</button>
		</div>
		<div class="container-fluid">
			<div class="row">
				<!-- Mixing Start -->
				<div class="col-4">
					<div class="panel h-100">
						<div class="panel-heading">Mixing</div>
						<div class="panel-body">
							<div class="container">
								<div
									class="mb-2 d-flex align-items-start justify-content-center"
								>
									<div class="component mt-2 text-center" style="width: 17rem">
										Formic acid concentrated
									</div>
								</div>

								<div
									class="mt-5 d-flex align-content-center justify-content-end position-relative"
								>
									<div
										class="component position-absolute font-size-1 font-weight-normal"
										style="width: 6rem; top: -20%; left: 30%"
									>
										<div>FT102</div>
										<div class="font-weight-bold">
											{{ setDeviceVolume("FT102_water") }}
										</div>
									</div>
									<div
										class="position-absolute mt-5"
										style="left: 43.5%; top: -60%"
									>
										<vertical-valve-component
											:status="setDeviceIconStatusOtherType('XSV114_status')"
											class="mb-1"
											label-right="XSV114"
											position="center"
										></vertical-valve-component>
										<vertical-line-component
											class="mt-n1"
											height="5rem"
											style="margin-left: 0.59rem"
										></vertical-line-component>
									</div>

									<horizontal-line-component
										class="position-absolute"
										style="top: 5.5rem; left: 5%"
										width="40rem"
									></horizontal-line-component>
									<two-way-horizontal-valve-component
										:status="setDeviceIconStatusOtherType('XSV101_status')"
										class="position-absolute mb-1"
										label-top="XSV101"
										position="center"
										style="top: 43.5%; left: 15%"
										width="8rem"
									></two-way-horizontal-valve-component>
									<vertical-line-component
										class="position-absolute"
										height="2rem"
										style="bottom: 31%; left: 3.5%"
									></vertical-line-component>

									<div
										class="position-absolute"
										style="bottom: -30%; left: -3%"
									>
										<div class="component">
											<div>Water</div>
											<div class="font-weight-normal">Volume FT101</div>
											<div>{{ setDeviceVolume("FT101_water") }}</div>
										</div>
									</div>

									<vertical-line-component
										class="position-absolute"
										height="3rem"
										style="bottom: -50%; left: 3.5%"
									></vertical-line-component>

									<div>
										<div class="component" style="width: 15rem">
											<div class="d-flex justify-content-between">
												<div class="font-weight-normal">
													<div>FAS1+</div>
													<div>Level LT106</div>
													<div class="font-weight-bold">
														{{ setDeviceLevel("LT106_level") }}
													</div>
												</div>
												<stirrer-component
													:status="setDeviceIconStatus('FAS1')"
													width="4rem"
												></stirrer-component>
											</div>

											<div class="d-flex mt-2">
												<div class="mr-2">
													<div class="font-weight-normal">PV</div>
													<div>{{ setDeviceInverterPV("FAS1") }}</div>
												</div>
												<div>
													<div class="font-weight-normal">SV</div>
													<div>{{ setDeviceInverterSV("FAS1") }}</div>
												</div>
											</div>
										</div>
									</div>
								</div>

								<div class="row position-relative" style="margin-top: 7rem">
									<div class="col d-flex">
										<horizontal-line-component
											class="position-absolute"
											style="top: -40%; left: 6.6%"
											width="46rem"
										></horizontal-line-component>
										<div
											class="bg-white position-absolute"
											style="right: -1%; top: -45%; width: 7.6rem; height: 2rem"
										></div>

										<div class="col flex-center"></div>
										<div class="col flex-center mr-3 mt-n3">
											<vertical-valve-component
												:status="setDeviceIconStatusOtherType('XSV105_STATUS')"
												label-right="XSV105"
											></vertical-valve-component>
										</div>
										<div class="col flex-center mr-3 mt-n3">
											<vertical-line-component
												height="5.4rem"
												label-right="XSV104"
											></vertical-line-component>
										</div>
										<div class="col flex-center mr-2 mt-n3">
											<vertical-line-component
												height="5.4rem"
												label-right="XSV103"
											></vertical-line-component>
										</div>
									</div>
								</div>

								<div class="row">
									<div class="col">
										<div class="d-flex align-items-start">
											<div class="mr-5 px-4 component">
												<div>Steam</div>
												<horizontal-line-component
													class="position-absolute"
													style="top: 35%; right: -50%"
													width="3.8rem"
												></horizontal-line-component>
											</div>
											<div class="component col mx-2">
												<div>Teric Acid</div>
												<div class="font-weight-normal">Level LT102</div>
												<div>{{ setDeviceLevel("LT102_level") }}</div>
											</div>
											<div class="component col mx-2 text-center">HNS</div>
											<div class="component col mx-2 text-center">Enzyme</div>
										</div>
									</div>
								</div>

								<div
									class="row position-relative"
									style="margin-top: -4rem; margin-left: -1.5rem"
								>
									<div class="col d-flex">
										<div class="col flex-center"></div>
										<div class="col flex-center mr-3">
											<vertical-line-component
												height="5rem"
											></vertical-line-component>
										</div>
										<div class="col flex-center mr-3">
											<vertical-line-component
												height="5rem"
											></vertical-line-component>
										</div>
										<div class="col flex-center mr-2">
											<vertical-line-component
												height="5rem"
											></vertical-line-component>
										</div>
									</div>
								</div>

								<div class="row position-relative">
									<div class="col d-flex">
										<div class="col flex-center"></div>
										<div class="col flex-center">
											<vertical-valve-component
												:status="setDeviceIconStatusOtherType('XSV109_status')"
												label-right="XSV109"
												style="padding-right: 2.1rem"
											></vertical-valve-component>
										</div>
										<div class="col flex-center">
											<vertical-valve-component
												:status="setDeviceIconStatusOtherType('XSV108_status')"
												label-right="XSV108"
												style="padding-right: 1.1rem"
											></vertical-valve-component>
										</div>
										<div class="col flex-center">
											<vertical-valve-component
												:status="setDeviceIconStatusOtherType('XSV107_status')"
												label-right="XSV107"
												style="padding-right: 0.16rem"
											></vertical-valve-component>
										</div>
									</div>
								</div>

								<div class="row position-relative" style="margin-left: -1.5rem">
									<div class="col d-flex">
										<horizontal-line-component
											class="position-absolute"
											style="bottom: -21%; left: 6.6%"
											width="46rem"
										></horizontal-line-component>
										<div
											class="bg-white position-absolute"
											style="right: -1%; top: 50%; width: 7.6rem; height: 2rem"
										></div>
										<two-way-horizontal-valve-component
											:status="setDeviceIconStatusOtherType('XSV106_status')"
											class="position-absolute"
											label-top="XSV106"
											position="center"
											style="top: 55%; left: 20%"
											width="8rem"
										></two-way-horizontal-valve-component>
										<div
											class="position-absolute component bg-white"
											style="bottom: -38%; width: 8rem; z-index: 1"
										>
											Water
										</div>

										<div class="col flex-center"></div>
										<div class="col flex-center mr-3">
											<vertical-line-component
												height="3rem"
											></vertical-line-component>
										</div>
										<div class="col flex-center mr-3">
											<vertical-line-component
												height="3rem"
											></vertical-line-component>
										</div>
										<div class="col flex-center mr-2">
											<vertical-line-component
												height="3rem"
											></vertical-line-component>
										</div>
									</div>
								</div>

								<div class="row mt-5">
									<div class="col position-relative">
										<vertical-line-component
											class="position-absolute"
											height="6rem"
											style="left: 8%; top: -7%"
										></vertical-line-component>
										<two-way-horizontal-valve-component
											:status="setDeviceIconStatusOtherType('XSV122_status')"
											class="position-absolute"
											label-top="XSV122"
											position="center"
											style="top: 10%; left: 9%"
											width="14rem"
										></two-way-horizontal-valve-component>
										<horizontal-line-component
											class="position-absolute"
											style="top: 11.3%; right: 32%"
											width="20rem"
										></horizontal-line-component>

										<horizontal-line-component
											class="position-absolute"
											style="top: 50%; left: 5%"
											width="40rem"
										></horizontal-line-component>
										<vertical-line-component
											class="position-absolute"
											height="3rem"
											style="right: 12.7%; top: -10.5%"
										></vertical-line-component>
										<div
											class="position-absolute component bg-white"
											style="top: 45.5%; width: 8rem; z-index: 1"
										>
											Latex
										</div>

										<pump-component
											:status="setDeviceIconStatusOtherType('XSV115_status')"
											class="position-absolute"
											label-top="XSV115"
											style="top: 44%; left: 30%"
											width="4rem"
										></pump-component>

										<div class="d-flex justify-content-end">
											<div
												class="bg-white p-2 border d-flex flex-column position-relative"
											>
												<div
													class="d-flex align-items-center justify-content-between"
												>
													<div class="font-weight-700">Mixing Tank</div>
													<div
														class="font-weight-bold component bg-grey text-white text-center"
														style="width: 40%"
													>
														{{ getBatchControllerStatus("WT102_bcStatus") }}
													</div>
												</div>

												<div class="component mt-3 mx-5">
													<div class="font-weight-normal">MXR2</div>
													<div class="d-flex justify-content-between">
														<div class="d-flex">
															<div class="font-weight-normal mr-2">PV</div>
															<div>{{ setDeviceInverterPV("MXR2") }}</div>
														</div>
														<div class="d-flex">
															<div class="font-weight-normal mr-2">SV</div>
															<div>{{ setDeviceInverterSV("MXR2") }}</div>
														</div>
													</div>
												</div>
												<div
													class="px-5 d-flex mt-1 align-items-center justify-content-center"
												>
													<tank-component
														:font-size="10"
														:value="setTankLevel('WT102_weight')"
														height="18rem"
														width="15rem"
													></tank-component>
												</div>
											</div>
										</div>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
				<!-- Mixing End -->

				<!-- Mixing tank readings start -->
				<div class="col-4">
					<div class="panel h-100">
						<div class="panel-heading">Mixing tank readings</div>
						<div class="panel-body">
							<div class="container">
								<div class="row">
									<div class="col-12">
										<div class="panel h-100">
											<div class="panel-heading">Overview</div>
											<div class="panel-body">
												<div class="row">
													<div class="col-6">Batch No.</div>
													<div class="col-6 font-weight-bold">
														{{
															!checkObjectEmpty(batch) &&
															batch.prepStartTimestamp !== undefined
																? batch.prepStartTimestamp
																: "-"
														}}
													</div>
												</div>
												<div class="row mt-2">
													<div class="col-6">Time elapse</div>
													<div class="col-6 font-weight-bold">
														{{
															!checkObjectEmpty(batch) &&
															batch.prepStartTimestamp !== undefined
																? calculateElapsedTime(
																		batch.prepStartTimestamp,
																		0
																  )
																: "-"
														}}
													</div>
												</div>
												<div class="row mt-2">
													<div class="col-6">Net weight (WT102)</div>
													<div class="col-6 font-weight-bold">
														{{ setDeviceWeight("WT102_weight") }}
													</div>
												</div>
												<div class="row mt-2">
													<div class="col-6">Gross weight (WT102)</div>
													<div class="col-6 font-weight-bold">
														{{ setDeviceGrossWeight("WT102_weight") }}
													</div>
												</div>
												<div class="row mt-2">
													<div class="col-6">pH Sensor (PHT102)</div>
													<div class="col-6 font-weight-bold">
														{{ setDevicePH("PHT102_ph") }}
													</div>
												</div>
												<div class="row mt-2">
													<div class="col-6">Stirrer (RCT102)</div>
													<div class="col-6 font-weight-bold">
														{{ setDeviceInverterPV("RCT102") }}
													</div>
												</div>
											</div>
										</div>
									</div>
								</div>

								<div class="row mt-4">
									<div class="col-6">
										<material-input-chart-component
											v-if="materialInputsChartData.length > 0"
											:recipes="materialInputsChartData"
										></material-input-chart-component>
										<div v-else>No material input data available</div>
									</div>
									<div class="col-6">
										<div class="panel">
											<div class="panel-heading">Material breakdown</div>
											<div class="panel-body">
												<div
													class="row"
													v-for="materialInput in materialInputs"
													:key="materialInput.material"
												>
													<div class="col-6">
														{{ materialInput.material | ucfirst }}
													</div>
													<div class="col-6 font-weight-bold">
														{{ materialInput.weight }} KG
													</div>
												</div>
											</div>
										</div>
									</div>
								</div>

								<div class="row mt-4">
									<div class="col-12">
										<div class="border">
											<material-chart-component
												:categories="materialCategories"
												:series="materialSeries"
												class="mb-3"
											></material-chart-component>
										</div>
									</div>
								</div>

								<div class="row mt-4">
									<div class="col-12">
										<div class="panel h-100">
											<div class="panel-heading">Runtime statistic</div>
											<div class="panel-body">
												<div class="row">
													<div class="col-6">Mixing</div>
													<div class="col-6 font-weight-bold">
														{{
															!checkObjectEmpty(batch) && batch.prepProcesses
																? calculateElapsedTime(
																		batch.prepProcesses[0].startTimestamp,
																		batch.prepProcesses[0].endTimestamp
																  )
																: "-"
														}}
													</div>
												</div>
											</div>
										</div>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
				<!-- Mixing tank readings end -->

				<div class="col-4">
					<div class="panel h-100">
						<div class="panel-heading">
							<div class="d-flex align-items-center">
								<div class="mr-4">Controls</div>
								<button
									class="py-1 btn"
									:class="
										!checkObjectEmpty(batch) && batch.operatingMode === 'START'
											? 'btn-blue'
											: 'btn-grey'
									"
									style="min-width: 15rem"
									v-if="mode === 'auto'"
									@click="validateCanStartNextProcess"
									:disabled="env === 'cloud'"
								>
									{{
										!checkObjectEmpty(batch)
											? batch.operatingMode.replace("_", " ")
											: "N/A"
									}}
								</button>
							</div>
						</div>
						<div class="panel-body">
							<div class="container px-0">
								<div class="row">
									<div class="col-12">
										<accordion-component>
											<accordion-item-component>
												<template slot="header">
													<div class="d-flex align-items-center">
														<h3>Material</h3>
													</div>
												</template>
												<template slot="content">
													<table>
														<thead>
															<tr class="px-2">
																<th>No.</th>
																<th>Code</th>
																<th class="text-left">Description</th>
																<th>SV</th>
															</tr>
														</thead>
														<tbody>
															<tr
																v-for="(parameter, index) in materialParameters"
																:key="index"
																:class="{
																	'edit-mode': parameter.editMode,
																	'readonly-mode': !parameter.editMode,
																}"
																class="px-2"
															>
																<td style="width: 10%">{{ index + 1 }}</td>
																<td style="width: 20%">
																	{{
																		parameter.code.includes("_")
																			? parameter.code.substring(
																					0,
																					parameter.code.indexOf("_")
																			  )
																			: parameter.code
																	}}
																</td>
																<td class="text-left" style="width: 40%">
																	{{ parameter.name }}
																</td>
																<td style="width: 20%">
																	<div
																		class="d-flex justify-content-center align-items-center"
																	>
																		<div v-if="!parameter.editMode">
																			{{
																				(parameter.sv || "-") + parameter.unit
																			}}
																		</div>
																		<input
																			v-else
																			v-model="materialUpdateData[index].sv"
																			type="text"
																		/>
																	</div>
																</td>
																<td></td>
																<td v-if="env !== 'cloud'">
																	<template
																		v-if="
																			checkBatchControllerActive(
																				'WT102_bcStatus'
																			)
																		"
																	>
																		<font-awesome-icon
																			icon="info-circle"
																			v-if="index === 0"
																			size="lg"
																			v-tooltip="'Batch controller is busy'"
																		/>
																	</template>
																	<template v-else>
																		<div
																			v-if="!parameter.editMode"
																			class="edit-btn"
																			@click="
																				toggleModeForMaterialParameters(index)
																			"
																		>
																			<font-awesome-icon icon="pencil-alt" />
																		</div>

																		<div
																			v-if="parameter.editMode"
																			class="d-flex"
																		>
																			<div
																				class="save-btn mr-2"
																				@click="
																					saveMaterialParameter(
																						parameter,
																						index
																					)
																				"
																			>
																				<font-awesome-icon icon="save" />
																			</div>
																			<div
																				class="cancel-btn"
																				@click="
																					toggleModeForMaterialParameters(index)
																				"
																			>
																				<font-awesome-icon
																					icon="window-close"
																				/>
																			</div>
																		</div>
																	</template>
																</td>
															</tr>
														</tbody>
													</table>
												</template>
											</accordion-item-component>

											<accordion-item-component>
												<template slot="header">
													<div class="d-flex align-items-center">
														<h3>Mixing</h3>
													</div>
												</template>
												<template slot="content">
													<table>
														<thead>
															<tr class="px-2">
																<th>No.</th>
																<th>Code</th>
																<th class="text-left">Description</th>
																<th>PV</th>
																<th>SV</th>
																<th>Status</th>
															</tr>
														</thead>
														<tbody>
															<tr
																v-for="(parameter, index) in mixingParameters"
																:key="index"
																:class="{
																	'edit-mode': parameter.editMode,
																	'readonly-mode': !parameter.editMode,
																}"
																class="px-2"
															>
																<td style="width: 10%">{{ index + 1 }}</td>
																<td style="width: 15%">{{ parameter.code }}</td>
																<td class="text-left" style="width: 30%">
																	{{ parameter.name }}
																</td>
																<td>
																	<!-- On Off type don't have PV and SV -->
																	<div
																		class="d-flex justify-content-center align-items-center"
																		v-if="parameter.type !== 'onOff'"
																	>
																		<div>
																			{{ setPVValueForParameter(parameter) }}
																		</div>
																	</div>
																</td>
																<td>
																	<!-- On Off type don't have PV and SV -->
																	<div
																		class="d-flex justify-content-center align-items-center"
																		v-if="parameter.type !== 'onOff'"
																	>
																		<div v-if="!parameter.editMode">
																			{{ setSVValueForParameter(parameter) }}
																		</div>
																		<input
																			v-else
																			v-model="mixingUpdateData[index].sv"
																			type="text"
																		/>
																	</div>
																</td>
																<td>
																	<template v-if="parameter.type !== 'temp'">
																		<p-check
																			v-if="parameter.editMode"
																			v-model="mixingUpdateData[index].status"
																			checked="parameter.status"
																			class="p-switch p-outline status-toggle"
																		></p-check>

																		<font-awesome-icon
																			v-else
																			:class="setStatusForParameter(parameter)"
																			icon="circle"
																		/>
																	</template>
																</td>
																<td v-if="env !== 'cloud'">
																	<template
																		v-if="
																			mode === 'semi-auto' ||
																			parameter.type === 'inverter'
																		"
																	>
																		<div
																			v-if="!parameter.editMode"
																			class="edit-btn"
																			@click="
																				toggleModeForMixingParameters(index)
																			"
																		>
																			<font-awesome-icon icon="pencil-alt" />
																		</div>

																		<div
																			v-if="parameter.editMode"
																			class="d-flex"
																		>
																			<div
																				class="save-btn mr-2"
																				@click="
																					saveMixingParameter(parameter, index)
																				"
																			>
																				<font-awesome-icon icon="save" />
																			</div>
																			<div
																				class="cancel-btn"
																				@click="
																					toggleModeForMixingParameters(index)
																				"
																			>
																				<font-awesome-icon
																					icon="window-close"
																				/>
																			</div>
																		</div>
																	</template>
																</td>
															</tr>
														</tbody>
													</table>
												</template>
											</accordion-item-component>
										</accordion-component>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</template>

<script>
import HorizontalLineComponent from "../../../components/productions/HorizontalLine";
import VerticalLineComponent from "../../../components/productions/VerticalLine";
import PumpComponent from "../../../components/productions/Pump";
import TwoWayHorizontalValveComponent from "../../../components/productions/TwoWayHorizontalValve";
import VerticalValveComponent from "../../../components/productions/VerticalValve";
import TankComponent from "../../../components/productions/Tank";
import StirrerComponent from "../../../components/productions/Stirrer";
import ModalComponent from "../../../components/modal/Modal";
import MaterialChart from "./MaterialChart";
import MaterialInputChart from "./MaterialInputChart";
import AccordionComponent from "../../../components/accordion/Accordion";
import AccordionItemComponent from "../../../components/accordion/AccordionItem";
import deviceMixin from "../../../mixins/device";
import parameterMixin from "../../../mixins/parameter";
import helperMixin from "../../../mixins/helper";
import timeMixin from "../../../mixins/time";
import { topics } from "@/utils/mqtt-topics";
import ControlService from "@/services/ControlService";
import { mapFields } from "vuex-map-fields";
import { CHART_INTERVAL } from "@/utils/constant";

// Import DayJS. Alternative to moment js. Better performance compare to moment.
import dayjs from "dayjs";
import RecipeService from "@/services/RecipeService";
import AutomationService from "@/services/AutomationService";

let parameters = require("../../../assets/data/parameters.json");
let materialInputs = require("../../../assets/data/material-input.json");
let materials = require("../../../assets/data/material.json");
let PRODUCT_ID = "DPNR";

export default {
	name: "dpnr-preparation-component",
	mixins: [deviceMixin, parameterMixin, helperMixin, timeMixin],
	components: {
		"vertical-valve-component": VerticalValveComponent,
		"horizontal-line-component": HorizontalLineComponent,
		"vertical-line-component": VerticalLineComponent,
		"pump-component": PumpComponent,
		"tank-component": TankComponent,
		"two-way-horizontal-valve-component": TwoWayHorizontalValveComponent,
		"stirrer-component": StirrerComponent,
		"modal-component": ModalComponent,
		"material-chart-component": MaterialChart,
		"accordion-component": AccordionComponent,
		"accordion-item-component": AccordionItemComponent,
		"material-input-chart-component": MaterialInputChart,
	},
	data() {
		return {
			env: process.env.VUE_APP_ENV,
			accessCode: "",
			materialParameters: [],
			materialUpdateData: [],
			mixingParameters: [],
			mixingUpdateData: [],
			device: {},
			topics: topics.dpnrPreparationPage,
			materialInputs: [],
			materialInputsChartData: [],
			materialCategories: [],
			materialSeries: [],
			batch: null,
			nextProcess: "N/A",
		};
	},
	methods: {
		/**
		 * Toggle mode between auto and semi auto.
		 */
		async toggleMode() {
			this.showLoadingOverlay();

			let validationPassed = await this.$refs.observer.validate();

			if (!validationPassed) {
				this.hideLoadingOverlay();
				return;
			}

			let userID = JSON.parse(window.localStorage.getItem("user")).id;
			let vm = this;
			let newMode = this.mode === "auto" ? false : true;

			// Request API to change automation mode.
			// If current mode is auto change to semi auto.
			// If current mode is semi auto change to auto.
			this.controlService
				.changeAutomationMode(this.accessCode, newMode, userID)
				.then((result) => {
					if (typeof result.response !== "undefined") {
						vm.hideModal("toggleModeModal");

						vm.$swal({
							title: "Error!",
							text: result.response.data.message,
							icon: "error",
							confirmButtonText: "OK",
						}).then(() => {
							vm.showModal("toggleModeModal");
						});

						vm.accessCode = "";
						vm.hideLoadingOverlay();
					} else {
						vm.hideLoadingOverlay();
						vm.hideModal("toggleModeModal");

						vm.mode = newMode ? "auto" : "semi-auto";
						vm.accessCode = "";

						vm.$swal({
							title: "Success!",
							text: result.data.message,
							icon: "success",
							confirmButtonText: "OK",
						});
					}
				});
		},

		/**
		 * Get all parameter for material and mixing from the parameters.json file.
		 *
		 * @returns {Promise<void>}
		 */
		getParameters: async function () {
			// Get material parameters.
			this.materialParameters = parameters.dpnr.material;

			// For material only can update the SV.
			this.materialParameters.forEach((parameter, index) => {
				this.$set(parameter, "editMode", false);
				this.$set(parameter, "sv", "");
			});

			// Get mixing parameters.
			this.mixingParameters = parameters.dpnr.mixing;
			this.mixingParameters.forEach((parameter, index) => {
				this.subscribeMQTTTopicDynamically(parameter);

				this.$set(parameter, "editMode", false);

				this.setDeviceData(parameter);
			});
		},

		/**
		 * Set device data. For material no need to set the device data because
		 * no need to listen to MQTT topic.
		 *
		 * Only for parameters like mixing, creeping, coagulation, cooling, heating.
		 *
		 * Need to set device data because if the topic not exist or not return the data,
		 * you still can update the parameter.
		 */
		setDeviceData(parameter) {
			// Set device data for parameter with inverter type.
			if (parameter.type === "inverter") {
				// The data must same with the data received from MQTT topic.
				// Example topic: lgm/device/FAS1
				let device = {
					isOn: false,
					isTripped: false,
					isAuto: false,
					opHz: null,
					refHz: null,
					device_id: parameter.code,
				};

				this.$set(this.device, parameter.code, device);
			}

			// Set device data for parameter with onOff type.
			if (parameter.type === "onOff") {
				// The data must same with the data received from MQTT topic.
				// Example topic: lgm/device/CCWP1
				let device = {
					isOn: false,
					isTripped: false,
					isAuto: false,
					device_id: parameter.code,
				};

				this.$set(this.device, parameter.code, device);
			}

			// Set device data for parameter with PID type.
			// Why need to set device data 2 times.
			// It because for parameter with PID type, you need to listen 2 MQTT topics.
			if (parameter.type === "pid") {
				// The data must same with the data received from MQTT topic.
				// Example topic: lgm/device/CCWP1
				let device = {
					isOn: false,
					isTripped: false,
					isAuto: false,
					device_id: parameter.code,
				};

				this.$set(this.device, parameter.code, device);

				// The data must same with the data received from MQTT topic.
				// Example topic: lgm/data/LT101/level
				device = {
					timestamp: null,
					value: null,
					sv: null,
					mv: null,
					status: 1,
					type: "level",
					device_id: parameter.code,
				};

				this.$set(this.device, parameter.code + "_level", device);
			}

			// Set device data for parameter with temp type.
			if (parameter.type === "temp") {
				// Special case for TT102 until TT105 because it contain operating mode.
				if (
					parameter.code === "TT102" ||
					parameter.code === "TT103" ||
					parameter.code === "TT104" ||
					parameter.code === "TT105"
				) {
					// The data must same with the data received from MQTT topic.
					// Example topic: lgm/data/TT102/temp
					let device = {
						timestamp: 1604754327415,
						value: 50,
						sv: 50,
						mv: 0,
						operatingMode: "heat",
						status: 1,
						type: "temp",
						device_id: "TT102",
					};

					this.$set(this.device, parameter.code + "_temp", device);
				} else {
					// The data must same with the data received from MQTT topic.
					// Example topic: lgm/data/TT106/temp
					let device = {
						timestamp: null,
						value: null,
						sv: null,
						mv: null,
						status: 1,
						type: "temp",
						device_id: parameter.code,
					};

					this.$set(this.device, parameter.code + "_temp", device);
				}
			}
		},

		/**
		 * Subscribe MQTT Topic dynamically for control parameters.
		 */
		subscribeMQTTTopicDynamically(parameter) {
			// Topic for device status.
			// Every device got this topic. Doesn't matter the parameter type whether inverter, temp, onOff or PID.
			// Example topic: lgm/device/FAS1
			let topic = ["lgm/device/" + parameter.code];

			// For parameter with PID type, need to subscribe additional topic to get the level data.
			if (parameter.type === "pid") {
				topic.push("lgm/data/" + parameter.code + "/level");
			}

			// For parameter with temp type, need to subscribe additional topic to get the temperature data.
			if (parameter.type === "temp") {
				topic.push("lgm/data/" + parameter.code + "/temp");
			}

			this.$mqtt.subscribe(topic, function (err, granted) {
				if (err) {
					console.log(
						"DPNR Preparations - Error During Subscription For Topic " + topic
					);
				}
				if (granted !== undefined) {
					granted.forEach(function (grant) {
						console.log(
							"DPNR Preparations - Subscribed to topic " + grant.topic
						);
					});
				}
			});
		},

		/**
		 * Toggle mode between read only and edit mode for material parameters.
		 *
		 * @param index
		 */
		toggleModeForMaterialParameters(index) {
			// Check if material parameter exist or not based on the index.
			if (typeof this.materialParameters[index] === "undefined") {
				return;
			}

			// Disable edit mode for other material parameter.
			// You can enable edit mode only for one parameter at a time.
			this.materialParameters.map(function (parameter, index1) {
				if (index != index1) {
					parameter.editMode = false;
					return parameter;
				}
			});

			// Get the material parameter data based on the index.
			let parameter = this.materialParameters[index];

			if (!parameter.editMode) {
				this.$swal({
					title: "Top up material",
					text:
						"Consider edit the Settings: Recipe if frequent top up is needed.",
					icon: "info",
					confirmButtonText: "OK",
				});
			}

			// If current parameter mode is edit mode, change to read only mode.
			if (this.materialParameters[index].editMode === true) {
				parameter.editMode = false;

				// Remove update data if user cancel edit mode.
				this.materialUpdateData.splice(index, 1);

				// If current parameter mode is read only mode, change to edit mode.
			} else {
				parameter.editMode = true;

				// Push empty data into update data array when user enable edit mode.
				this.materialUpdateData[index] = {
					code: this.materialParameters[index].code,
					sv: this.materialParameters[index].sv,
				};
			}
		},

		/**
		 * Save updated data for material parameter.
		 *
		 * @param parameter
		 */
		saveMaterialParameter(parameter, index) {
			this.showLoadingOverlay();

			// Need to request API to save.
			let validationFailed = false;
			let errorMessage = "";

			// Validate the SV value empty or not.
			// If empty set the validation result as failed.
			if (!this.materialUpdateData[index].sv) {
				validationFailed = true;
				errorMessage = "SV value is required";
			}

			// Validate the SV value numeric or not.
			// If the SV value not a number set the validation result as failed.
			// Can accept decimal and negative number.
			if (isNaN(this.materialUpdateData[index].sv)) {
				validationFailed = true;
				errorMessage = "SV value must be a number.";
			}

			// Show an error message in popup if validation failed.
			if (validationFailed) {
				this.hideLoadingOverlay();
				this.$swal({
					title: "Error!",
					text: errorMessage,
					icon: "error",
					confirmButtonText: "OK",
				});
				return;
			}

			let vm = this;

			// Call top up material API.
			this.controlService
				.topUpMaterial(
					this.materialUpdateData[index].code,
					this.materialUpdateData[index].sv
				)
				.then((result) => {
					this.hideLoadingOverlay();

					if (typeof result.response !== "undefined") {
						this.displayErrorPopup(result);
						return;
					}

					// Disable edit mode.
					vm.materialParameters[index].editMode = false;
					vm.materialParameters[index].sv = vm.materialUpdateData[index].sv;

					var code = vm.materialUpdateData[index].code;
					if (code.includes("_")) {
						code = code.substring(0, parameter.code.indexOf("_"));
					}

					vm.$swal({
						title: "Success",
						html:
							"<div>Successfully updating the material parameter " +
							code +
							".</div>",
						icon: "success",
						confirmButtonText: "OK",
					});

					// Remove update data after successfully save.
					vm.materialUpdateData.splice(index, 1);
				});
		},

		/**
		 * Toggle mode between read only and edit mode for mixing parameters.
		 *
		 * @param index
		 */
		toggleModeForMixingParameters(index) {
			// Empty the mixing update data.
			this.mixingUpdateData = [];

			// Check if the index is exist in mixing parameters.
			if (typeof this.mixingParameters[index] === "undefined") {
				return;
			}

			// This function used to change other parameter mode to read only.
			// Let say you 3 parameters. Parameter A, Parameter B and Parameter C.
			// When you edit Paramter A, Parameter B and C mode will change to read only.
			this.mixingParameters.map(function (parameter, index1) {
				if (index != index1) {
					parameter.editMode = false;
					return parameter;
				}
			});

			// Get the parameter data based on the index.
			let parameter = this.mixingParameters[index];

			// If current mode is edit mode, change to read only mode.
			if (this.mixingParameters[index].editMode === true) {
				parameter.editMode = false;

				// If current mode is read only mode, change to edit mode.
			} else {
				parameter.editMode = true;

				let status = false;

				// Set the status based on the 'isOn' & 'isTripped attribute.
				// The status either on or off.
				// For parameter with temp type, no need to display status.
				if (parameter.type !== "temp") {
					if (this.device[parameter.code].isTripped) {
						status = false;
					}

					if (this.device[parameter.code].isOn) {
						status = true;
					}
				}

				// Set initial update data for parameter with type inverter.
				// For inverter you can update both (SV and status).
				if (parameter.type === "inverter") {
					this.mixingUpdateData[index] = {
						code: this.mixingParameters[index].code,
						sv: this.device[parameter.code].refHz,
						status: status,
					};
				}

				// Set initial update data for parameter with type PID.
				// For PID type you can update both (SV and status).
				if (parameter.type === "pid") {
					this.mixingUpdateData[index] = {
						code: this.mixingParameters[index].code,
						sv: this.device[parameter.code + "_level"].sv,
						status: status,
					};
				}

				// Set initial update data for parameter with type onOff.
				// For onOff type you only can update status.
				if (parameter.type === "onOff") {
					this.mixingUpdateData[index] = {
						code: this.mixingParameters[index].code,
						status: status,
					};
				}

				// Set initial update data for parameter with type temp.
				// For temp type you only can update SV.
				// Special case for TT102 until TT105 where you can update operating mode.
				if (parameter.type === "temp") {
					if (
						parameter.code === "TT102" ||
						parameter.code === "TT103" ||
						parameter.code === "TT104" ||
						parameter.code === "TT105"
					) {
						this.mixingUpdateData[index] = {
							code: this.mixingParameters[index].code,
							sv: this.device[parameter.code + "_temp"].sv,
							operatingMode: this.device[parameter.code + "_temp"]
								.operatingMode,
						};
					} else {
						this.mixingUpdateData[index] = {
							code: this.mixingParameters[index].code,
							sv: this.device[parameter.code + "_temp"].sv,
						};
					}
				}
			}

			this.$set(this.mixingParameters, index, parameter);
		},

		/**
		 * Save updated data for mixing parameter.
		 *
		 * @param parameter
		 */
		async saveMixingParameter(parameter, index) {
			// Clear the error message and set validation fail to false.
			let validationFailed = false;
			let errorMessage = "";

			// Only check validation for parameter type inverter,pid,temp
			// because for parameter with onOff type don't have SV.
			if (parameter.type !== "onOff") {
				// Empty validation for SV.
				if (!this.mixingUpdateData[index].sv) {
					validationFailed = true;
					errorMessage = "SV value is required";
				}

				// Integer validation for SV.
				if (
					Number(this.mixingUpdateData[index].sv) !=
						this.mixingUpdateData[index].sv ||
					this.mixingUpdateData[index].sv % 1 !== 0
				) {
					validationFailed = true;
					errorMessage = "SV value must be a number.";
				}

				// Validate range value for inverter.
				// For inverter the range is between 0 and 50.
				if (
					parameter.type === "inverter" &&
					(this.mixingUpdateData[index].sv > 50 ||
						this.mixingUpdateData[index].sv < 0)
				) {
					validationFailed = true;
					errorMessage =
						"Allowed range for inverter SV value is between 0 and 50.";
				}

				// Validate range value for pid.
				// For PID the range is between 0 and 100.
				if (
					parameter.type === "pid" &&
					(this.mixingUpdateData[index].sv > 100 ||
						this.mixingUpdateData[index].sv < 0)
				) {
					validationFailed = true;
					errorMessage = "Allowed range for pid SV value is between 0 and 100.";
				}

				// If validation failed show an error message in popup.
				if (validationFailed) {
					this.$swal({
						title: "Error!",
						text: errorMessage,
						icon: "error",
						confirmButtonText: "OK",
					});

					return;
				}
			}

			this.showLoadingOverlay();

			// Need to check the parameter type because the API need request to update the data is different.
			if (this.mixingParameters[index].type === "inverter") {
				let result = await this.controlService.setDeviceState(
					this.mixingUpdateData[index].code,
					this.mixingUpdateData[index].status
				);

				if (typeof result.response !== "undefined") {
					this.displayErrorPopup(result);
					return;
				}

				result = await this.controlService.setInverterHz(
					this.mixingUpdateData[index].code,
					this.mixingUpdateData[index].sv
				);

				if (typeof result.response !== "undefined") {
					this.displayErrorPopup(result);
					return;
				}

				this.device[parameter.code].refHz = this.mixingUpdateData[index].sv;
			}

			if (this.mixingParameters[index].type === "onOff") {
				let result = await this.controlService.setDeviceState(
					this.mixingUpdateData[index].code,
					this.mixingUpdateData[index].status
				);

				if (typeof result.response !== "undefined") {
					this.displayErrorPopup(result);
					return;
				}
			}

			if (this.mixingParameters[index].type === "pid") {
				let result = await this.controlService.setDeviceState(
					this.mixingUpdateData[index].code,
					this.mixingUpdateData[index].status
				);

				if (typeof result.response !== "undefined") {
					this.displayErrorPopup(result);
					return;
				}

				result = await this.controlService.setDeviceValue(
					this.mixingUpdateData[index].code,
					this.mixingUpdateData[index].sv
				);

				if (typeof result.response !== "undefined") {
					this.displayErrorPopup(result);
					return;
				}

				this.device[parameter.code + "_level"].sv = this.mixingUpdateData[
					index
				].sv;
			}

			if (this.mixingParameters[index].type === "temp") {
				if (
					parameter.code === "TT102" ||
					parameter.code === "TT103" ||
					parameter.code === "TT104" ||
					parameter.code === "TT105"
				) {
					let result = await this.controlService.changeDeviceMode(
						this.mixingUpdateData[index].code,
						this.mixingUpdateData[index].status
					);

					if (typeof result.response !== "undefined") {
						this.displayErrorPopup(result);
						return;
					}
				}

				let result = await this.controlService.setDeviceValue(
					this.mixingUpdateData[index].code,
					this.mixingUpdateData[index].sv
				);

				if (typeof result.response !== "undefined") {
					this.displayErrorPopup(result);
					return;
				}

				this.device[parameter.code + "_temp"].sv = this.mixingUpdateData[
					index
				].sv;
				this.device[parameter.code + "_temp"].mode = this.mixingUpdateData[
					index
				].mode;
			}

			// Update device status based on status update value.
			// For parameter with type temp don't have status.
			// No need to update for temp.
			let statusObjectKey = parameter.code;

			if (parameter.type !== "temp") {
				this.device[statusObjectKey].isTripped = false;

				if (this.mixingUpdateData[index].status) {
					this.device[statusObjectKey].isOn = true;
				} else {
					this.device[statusObjectKey].isOn = false;
				}
			}

			// Disable edit mode.
			this.mixingParameters[index].editMode = false;

			this.$swal({
				title: "Success",
				html:
					"<div>Successfully updated the mixing parameter " +
					this.mixingUpdateData[index].code +
					".</div>",
				icon: "success",
				confirmButtonText: "OK",
			});

			// Remove update data after successfully save.
			this.mixingUpdateData.splice(index, 1);

			this.hideLoadingOverlay();
		},

		/**
		 * Get DPNR material inputs. Used to display the data in the pie chart
		 * and material breakdown.
		 */
		async getMaterialInputs() {
			let recipeBreakdown = await this.recipeService.getRecipeBreakdownOfCurrentBatch(
				PRODUCT_ID
			);
			let data = recipeBreakdown.data.data;
			if (data !== undefined && data.materials !== undefined) {
				let materialInputs = data.meterials;

				this.materialInputs = materialInputs;
				materialInputs.forEach((material) => {
					this.materialInputsChartData.push({
						name:
							material.material.substr(0, 1).toUpperCase() +
							material.material.substr(1).toLowerCase(),
						y: material.weight,
					});
				});
			}
		},

		/**
		 * Get DPNR material. Used to display the data in stacked material bar chart.
		 */
		async getMaterials() {
			let counter = 0;
			let categories = [];
			let series = [];
            let materialsName = []

			if (this.batch) {
				let startTimestamp = this.batch.prepStartTimestamp;
				let currentTimestamp = dayjs(dayjs()).valueOf();

				let recipeBreakdown = await this.recipeService.getRecipeBreakdown(
					"WT102",
					startTimestamp,
					currentTimestamp,
					CHART_INTERVAL
				);

				if (typeof recipeBreakdown.response !== "undefined") {
					this.displayErrorPopup(result);
					return;
				} else {
					const { data } = recipeBreakdown.data;
					// console.log('getRecipeBreakdown', data.reading)

					// series.push({
					//     type: 'column',
					//     name: key.substr(0, 1).toUpperCase() + key.substr(1).toLowerCase(),
					//     data: values
					// });
					// categories.push(dayjs(timestamp).format('HH:mm A'));
				}
			}

			let last7Bathches = await this.recipeService.getRecipeBreakdownOfBatches(
				0,
				7,
				PRODUCT_ID
			);
			let recipes = last7Bathches.data.data.recipes.reverse()

			// Generate data based on the highchart format.
			// Need to have categories and series.
            let batches = [];
			recipes.forEach((recipe, index) => {
                categories.push(dayjs((recipe.startTimestamp)).format('DD/MM/YY'));
                materialsName.push(recipe.meterials.map(material => material.material))
                let values = recipe.meterials.map(material => {
                    return {
                        name: material.material,
                        data: material.weight
                    }
                });
                batches.push(values)
			});
            var uniqueMaterials = materialsName.flat().filter((v, i, a) => a.indexOf(v) === i);
            uniqueMaterials.forEach(materialName => {
                let data = batches.map(batch => {
                    let value = batch.find(item => item.name === materialName)
                    if (value) {
                        return value.data
                    }
                    return 0
                });
                // console.log(data)
                series.push({
                    name: materialName,
                    data: data
                });
            })            
            
			this.materialCategories = categories;
			this.materialSeries = series;
		},

		/**
		 * Validate next process can start or not. Must start DPNR process first (Step 1).
		 * And then soaking status is false in DPNR Production batch data.
		 * The batch data get from Vuex.
		 */
		validateCanStartNextProcess() {
			// Check if DPNR process already start.
			// If not start, show an error message in popup.
			if (this.prepDPNR.productId !== "DPNR" && !this.prepDPNR.isActive) {
				this.$swal({
					title: "Error",
					html:
						"You must start DPNR preparation process first before you can start the mixing process.",
					icon: "error",
					confirmButtonText: "OK",
				});
				return;
			}

			if (this.nextProcess !== "MIXING") {
				return;
			}

			this.showModal("startNextProcessModal");
		},

		/**
		 * Start next process
		 */
		async startNextProcess() {
			this.hideModal("startNextProcessModal");

			this.showLoadingOverlay();

			let nextProcess =
				this.nextProcess.substr(0, 1).toUpperCase() +
				this.nextProcess.substr(1).toLowerCase();

			let result = await this.controlService.startNextBatchProcess("prepDpnr");

			if (typeof result.response !== "undefined") {
				this.displayErrorPopup(result);
				return;
			}

			this.hideLoadingOverlay();

			this.$swal({
				title: "Success",
				html:
					"Successfully start DPNR preparation " + nextProcess + " process.",
				icon: "success",
				confirmButtonText: "OK",
			});
		},

		/**
		 *  Get next process.
		 */
		getNextProcess() {
			if (this.checkObjectEmpty(this.batch)) {
				this.nextProcess = "N/A";
				return;
			}

			if (this.batch.operatingMode === "START") {
				this.nextProcess = "MIXING";
				return;
			}

			if (this.batch.operatingMode === "MIXING") {
				this.nextProcess = "END_PREP";
				return;
			}

			return "N/A";
		},
	},
	computed: {
		/**
		 * The `mapFields` function takes an array of field names and generates corresponding
		 * computed properties with getter and setter functions for accessing the Vuex store.
		 */
		...mapFields(["mode", "prepDPNR"]),

		/**
		 * Create ControlService instance.
		 *
		 * @returns {ControlService}
		 */
		controlService: function () {
			return new ControlService();
		},

		/**
		 * Create RecipeService instance.
		 *
		 * @returns {RecipeService}
		 */
		recipeService: function () {
			return new RecipeService();
		},

		/**
		 * Create AutomationService instance.
		 *
		 * @returns {AutomationService}
		 */
		automationService: function () {
			return new AutomationService();
		},
	},
	mqtt: {
		/**
		 * Listen for device status.
		 * If the device is inverter, it contains PV and SV.
		 */
		"lgm/device/+"(message, topic) {
			// console.log("\nDPNR Preparations - Received message from " + topic + " topic at " + new Date().toLocaleString())
			// console.log("DPNR Preparations - The message was " + message.toString());

			message = JSON.parse(message.toString());

			this.$set(this.device, message.device_id, message);
		},

		/**
		 * Listen for specific device data.
		 * For example device temperature, level and PID.
		 */
		"lgm/data/+/+"(message, topic) {
			// console.log("\nDPNR Preparations - Received message from " + topic + " topic at " + new Date().toLocaleString())
			// console.log("DPNR Preparations - The message was " + message.toString());

			message = JSON.parse(message.toString());

			this.$set(this.device, message.device_id + "_" + message.type, message);
		},

		/**
		 * Listen for running mode whether semi auto mode or auto mode.
		 */
		"lgm/data/autoMode/status"(message, topic) {
			// console.log("\nDPNR Preparations - Received message from " + topic + " topic at " + new Date().toLocaleString())
			// console.log("DPNR Preparations - The message was " + message.toString());

			message = JSON.parse(message.toString());

			if (message.status === 1) {
				this.mode = "auto";
			} else {
				this.mode = "semi-auto";
			}
		},

		/**
		 * Listen for DPNR prep batch data.
		 * The data contain which process currently active.
		 * From this data, system can know whether mixing process can start or the mixing
		 * process already run.
		 *
		 * @param message
		 * @param topic
		 */
		"lgm/batch/prepDpnr"(message, topic) {
			// console.log("\nDPNR Preparations - Received message from " + topic + " topic at " + new Date().toLocaleString())
			// console.log("DPNR Preparations - The message was " + message.toString());

			if (message.toString()) {
				message = JSON.parse(message.toString());

				if (message && !this.checkObjectEmpty(message)) {
					this.batch = message;

					this.getNextProcess(message);
				}
			}
		},
	},
	mounted() {
		this.$mqtt.subscribe(this.topics, function (err, granted) {
			if (err) {
				console.log("DPNR Preparations - Error During Subscription :" + err);
			} else {
				console.log("DPNR Preparations - No Error During Subscription");
			}
			if (granted !== undefined) {
				granted.forEach(function (grant) {
					console.log("DPNR Preparations - Subscribed to topic " + grant.topic);
				});
			}
		});

		this.automationService.getCurrentBatchByStage("prepDpnr").then((result) => {
			if (typeof result.response !== "undefined") {
				this.displayErrorPopup(result);
				return;
			}

			this.batch = result.data.data;

			this.getNextProcess(result.data.data);

			// Get material inputs data for pie chart and material breakdown section.
			this.getMaterialInputs();

			// Get materials data for stacked bar chart.
			this.getMaterials();
		});

		// Get control parameters.
		this.getParameters();
	},
	beforeDestroy() {
		// Unsubscribe MQTT topic when component being destroy.
		if (this.topics.length > 0) {
			this.$mqtt.unsubscribe(this.topics);
		}
	},
};
</script>

<style lang="scss" scoped>
@import "../../../assets/styles/pages/productions/dpnr.scss";
</style>
